#!/usr/bin/env python3
# encoding: UTF-8

import cgitb; cgitb.enable()
import sys, os, glob
from pygments import highlight
from pygments.lexers import PythonLexer
from pygments.formatters import HtmlFormatter

sources = sorted(glob.glob("*.py"))
for py in sources:
    html = open(py + ".html", "w")
    print = html.write
    print("<html>")
    print("<head>")
    print('<style type="text/css">')
    print(HtmlFormatter().get_style_defs(".highlight"))
    print("""

body {
    font-family: sans-serif;
}

ul.list {
    border-bottom: 1px solid black;
    list-style-type: none;
    margin: 1em 0;
    padding: 3px 10px;
    text-align: left;
}
ul.list li {
    display: inline;
}
ul.list li.selected {
    background-color: #FFFFFF;
    border-bottom: 1px solid #FFFFFF;
}
ul.list li.selected a {
    background-color: #FFFFFF;
    color: blue;
    padding-top: 4px;
    position: relative;
    top: 1px;
}
ul.list li a {
    background-color: #e0e0e0;
    border-color: black;
    border-image: none;
    border-style: solid solid none;
    border-width: 1px 1px medium;
    color: black;
    margin-left: 4px;
    margin-right: 0;
    padding: 3px 4px;
    text-decoration: none;
}
ul.list a:hover {
    background: none repeat scroll 0 0 #FFFFFF;
}

""")
    print('</style>')
    print("<title>" + py + "</title>")
    print("</head>")
    print("<body>")
    print("<ul class=\"list\">")
    for s in sources:
        if s == py:
            print("<li class=\"selected\">")
        else:
            print("<li>")
        print("<a href=\"" + s + ".html\">" + s + "</a>")
        print("</li>")
    print("</ul>")
    code = open(py).read()

    print(highlight(code, PythonLexer(), HtmlFormatter()))

    print("</body>")
    print("</html>")
