import player
import tilemap
import monster
import creature

class Game:
    def __init__(self):
        player.game = self
        tilemap.game = self
        monster.game = self
        creature.game = self

        self.key_left = False
        self.key_right = False
        self.key_up = False
        self.key_down = False
        self.click = False
        self.mx = 0
        self.my = 0
        self.scroll_x = 0
        self.scroll_y = 0

    def init(self):
        self.backup_layers = [None] * 6
        for i in range(5):
            self.backup_layers[i] = self.tilemap.layers[i][:]
        self.reset()

    def reset(self):
        for i in range(5):
            self.tilemap.layers[i] = self.backup_layers[i][:]

        self.dead = 0
        self.victorious = False
        self.players = []
        self.player = player.Player()
        self.players.append(self.player)

        monsters = ["bat", "bee", "big_worm", "ghost",
            "man_eater_flower", "eyeball", "pumpking", "slime", "small_worm", "snake"]
        mid = 0

        for ty in range(100):
            for tx in range(100):
                if self.tilemap.layers[2][tx + self.tilemap.w * ty] == 4:
                    m = monster.Monster(monsters[mid])
                    m.x = tx * 32
                    m.y = ty * 32
                    mid += 1
                    mid %= 10
        #logger.debug("{} spawns found".format(mid))

    def tick(self):

        dead = 0
        i = 0
        for p in self.players:
            p.tick()
            if i > 0:
                if p.dieing:
                    dead += 1
            i += 1

        if self.players[0].dieing > 64:
            self.canvas.text.setHTML(
                "\"Darkness has consumed thee!\" proclaimed the wizard and " +
                "quickly cast a spell to reset the land of Kaos."
                + "<br />" +
                self.canvas.text.getHTML())
            self.reset()
            return

        if dead > self.dead:
            self.dead = dead
            if self.dead == 10:
                self.canvas.text.setHTML(
                    "\"Thou art victorious!\" proclaimed the wizard and cast " +
                    "a spell to teleport the princess back home to her castle."
                    + "<br />" +
                    self.canvas.text.getHTML())
                self.players[0].x = 46 * 32
                self.players[0].y = 94 * 32
                self.victorious = True
            else:
                self.canvas.text.setHTML(
                    "A creature of Kaos has been swallowed. {} more remain."
                    .format(10 - self.dead) + "<br />" +
                    self.canvas.text.getHTML())

        self.click = False

    def draw(self, canvas):
        self.scroll_x = self.player.x - 320
        self.scroll_y = self.player.y - 180
        self.tilemap.draw(canvas, self.scroll_x, self.scroll_y)
