import random, math
from creature import Creature

class Monster(Creature):
    def __init__(self, sheet):
        Creature.__init__(self)
        self.sheet = game.images[sheet]
        self.angle = 0
        self.t = 0

        self.sx = self.sheet.w // 3
        self.sy = self.sheet.h // 4

        game.players.append(self)

    def tick(self):

        Creature.tick(self, False)

        self.f += 1
        self.f &= 7
        self.u = self.f // 2 if self.f < 6 else 1

        if self.t > 0:
            self.t -= 1
            dx = math.cos(self.angle)
            dy = math.sin(self.angle)

            if dy < 0:
                self.v = 0
            if dy > 0:
                self.v = 2
            if dx < -0.6:
                self.v = 1
            if dx > 0.6:
                self.v = 3

            self.try_move(dx * 3, 0)
            self.try_move(0, dy * 3)

        else:
            self.t = random.randint(20, 80)
            self.angle = random.random() * math.pi * 2

    def draw(self, canvas, scroll_x, scroll_y):
        p = self
        sx, sy = self.sx, self.sy
        x = p.x - scroll_x - sx // 2
        y = p.y - sy - scroll_y

        if self.dieing:
            s = self.dieing
            if s >= sy:
                return
        else:
            s = 0

        canvas.drawImage(self.sheet,
            p.u * sx, p.v * sy, sx, sy - s, x, y + s, sx, sy - s)
