from math import *
from creature import Creature

class Player(Creature):
    def __init__(self):
        Creature.__init__(self)
        self.target = None
        self.trail = []

    def tick(self):

        Creature.tick(self, True)

        dx, dy = 0, 0

        if game.click:
            self.target = game.mx, game.my

        if self.target:
            mx, my = self.target
            if self.x < mx - 4:
                dx = 1
            if self.x > mx + 4:
                dx = -1
            if self.y < my - 4:
                dy = 1
            if self.y > my + 4:
                dy = -1

            if dx == 0 and dy == 0:
                self.target = None

        if game.key_up:
            dy -= 1
        if game.key_down:
            dy += 1
        if game.key_left:
            dx -= 1
        if game.key_right:
            dx += 1

        if dx or dy:
            if dy < 0:
                self.v = 0
            if dy > 0:
                self.v = 2
            if dx < 0:
                self.v = 1
            if dx > 0:
                self.v = 3
            self.f += 1
            self.u = 1 + (self.f // 1) & 7

            self.try_move(dx * 4, 0)
            self.do_trail()
            self.try_move(0, dy * 4)
            self.do_trail()


        else:
            self.u = 0
            self.f = 0

    def do_trail(self):
        tx = self.x // 32
        ty = self.y // 32
        if len(self.trail) == 0 or (tx, ty) != self.trail[-1]:
            self.trail.append((tx, ty))
            game.tilemap.layers[1][tx + game.tilemap.w * ty] = 118
            if len(self.trail) > 3:
                tx, ty = self.trail[0]
                self.trail = self.trail[-3:]
                if not game.victorious:
                    place_darkness(tx, ty)

    def draw(self, canvas, scroll_x, scroll_y):
        if self.dieing:
            s = self.dieing
            if s >= 64:
                return
        else:
            s = 0

        p = self
        x = p.x - scroll_x - 32
        y = p.y - 56 - scroll_y
        canvas.drawImage(game.images["female_walkcycle"],
            p.u * 64, p.v * 64, 64, 64 - s, x, y + s, 64, 64 - s)
        canvas.drawImage(game.images["female_dress"],
            p.u * 64, p.v * 64, 64, 64 - s, x, y + s, 64, 64 - s)
        canvas.drawImage(game.images["female_hair"],
            p.u * 64, p.v * 64, 64, 64 - s, x, y + s, 64, 64 - s)

def check_darkness(tx, ty):
    l = game.tilemap.layers[3]
    w = game.tilemap.w
    if l[tx + w * ty] == 125:
        return
    m = 0
    bit = 1
    for v in (-1, 0, 1):
        for u in (-1, 0, 1):
            if l[tx + u + w * (ty + v)] == 125:
                m += bit
            bit <<= 1

    r = 0
    if m & 2 == 2: r = 14
    if m & 8 == 8: r = 12
    if m & 32 == 32: r = 10
    if m & 128 == 128: r = 8

    if m & 416 == 256: r = 7
    if m & 200 == 64: r = 9
    if m & 38 == 4: r = 13
    if m & 11 == 1: r = 15

    if m & 10 == 10: r = 2
    if m & 34 == 34: r = 3
    if m & 136 == 136: r = 5
    if m & 160 == 160: r = 6

    if m & 40 == 40: r = 11
    if m & 130 == 130: r = 11
    if m & 68 == 68: r = 11
    if m & 257 == 257: r = 11

    if r:
        if r == 11:
            place_darkness(tx, ty)
        else:
            l[tx + w * ty] = 114 + r

def place_darkness(tx, ty):
    l = game.tilemap.layers
    w = game.tilemap.w
    l[3][tx + w * ty] = 125
    l[2][tx + w * ty] = 0
    l[1][tx + w * ty] = 0
    l[0][tx + w * ty] = 0
    for v in (-1, 0, 1):
        for u in (-1, 0, 1):
            check_darkness(tx + u, ty + v)
