class Tilemap:

    def __init__(self):
        self.tilesets = {}
        self.layers = []

    def read_data(self, data, images):
        self.w = data["width"]
        self.h = data["height"]
        self.tw = data["tilewidth"]
        self.th = data["tileheight"]
        for tileset in data["tilesets"]:
            i = tileset["firstgid"]
            pic = images[tileset["name"]]
            tw = tileset["tilewidth"]
            th = tileset["tileheight"]
            xt = tileset["imagewidth"] // tw
            yt = tileset["imageheight"] // th
            for yi in range(yt):
                for xi in range(xt):
                    self.tilesets[i + yi * xt + xi] = pic, xi * tw, yi * th,\
                        tw, th
            #logger.debug("read tileset " + tileset["name"])
        for layer in data["layers"]:
            tiledata = layer["data"]
            self.layers.append(tiledata)
            #logger.debug("read layer " + layer["name"] + " %d tiles" % len(tiledata))

    def draw(self, canvas, scroll_x, scroll_y):
        tx = scroll_x // 32 - 2
        ty = scroll_y // 32 - 1
        ox = tx * 32 - scroll_x
        oy = ty * 32 - scroll_y
        for i, layer in enumerate(self.layers):
            for y in range(12 + 4):
                if ty + y < 0: continue
                if ty + y >= 100: break
                for x in range(20 + 3):
                    t = layer[tx + x + self.w * (ty + y)]
                    if not t:
                        continue
                    tileset, xo, yo, tw, th = self.tilesets[t]
                    canvas.drawImage(tileset, xo, yo, tw, th,
                        ox + x * 32, oy + y * 32 + 32 - th, tw, th)
            if i == 3:
                for player in game.players:
                    player.draw(canvas, scroll_x, scroll_y)
